<template>
  <div class="d-flex flex-column" style="width: 100%">
    <v-tabs>
      <v-tabs-slider></v-tabs-slider>
      <v-tab>Общее</v-tab>
      <v-tab>Вопросы</v-tab>
      <v-tab-item
        ><FormBuilder
          :schema="BaseInfo"
          v-model="testData.baseInfo"
          @change="changeFormHandler"
      /></v-tab-item>
      <v-tab-item>
        <v-row>
          <v-col cols="12" class="d-flex justify-end">
            <v-btn color="primary" @click="createQuestion">
              <v-icon color="white">mdi-plus</v-icon>Создать вопрос
            </v-btn>
          </v-col>
        </v-row>
        <v-row>
          <v-col cols="12" lg="5">
            <div class="d-flex flex-column">
              <span>Количество вопросов: {{ testData.questions.length }}</span>
              <v-list>
                <v-list-item-group color="primary">
                  <v-list-item v-for="(item, i) in testData.questions" :key="i">
                    <v-list-item-content>
                      <v-list-item-title
                      style="max-width: 350px;overflow: hidden"
                      >
                      <span  v-text="item.condition.text"></span>
                      </v-list-item-title>
                    </v-list-item-content>
                    <v-list-item-icon
                      ><v-icon @click="editQuestion(item.id)"
                        >mdi-pencil</v-icon
                      ></v-list-item-icon
                    >
                    <v-list-item-icon
                      ><v-icon @click="deleteQuestion(item.id)"
                        >mdi-delete</v-icon
                      ></v-list-item-icon
                    >
                  </v-list-item>
                </v-list-item-group>
              </v-list>
            </div>
          </v-col>
          <v-col cols="12" lg="5">
            <QuestionBuilder
              v-if="isBuildMode"
              :question="editableQuestion"
              @create-question="createHandle"
              @edit-question="saveEditedQuestion"
              @cancel="cancelHandle"
            />
          </v-col>
        </v-row>
      </v-tab-item>
    </v-tabs>
    <v-snackbar
      v-model="showSnackBar"
      v-text="snackBarText"
      color="success"
      :timeout="3000"
    />
  </div>
</template>
<script>
import MCard from "@/components/material/Card";
import { VTextField, VSelect } from "vuetify/lib";
import { mapState } from "vuex";

export default {
  components: {
    "meterial-card": MCard
  },
  model: {
    prop: "test"
  },
  props: {
    test: {
      type: Object
    }
  },
  data() {
    return {
      showSnackBar: false,
      editableQuestion: null,
      tab: null,
      tabs: 0,
      snackBarText: "",
      testData: {
        baseInfo: {
          name: this.test.name || null,
          type: this.test.type || null,
          groups: this.test.groups || []
        },
        questions: this.test.questions || []
      },
      BaseInfoData: {},
      isBuildMode: false
    };
  },
  watch: {
    test: {
      deep: true,
      handler(nV, oV) {
        if (nV !== oV && Object.keys(oV).length == 0) {
          const { name, type, groups, questions } = nV;
          this.testData.baseInfo = {
            name,
            type,
            groups
          };
          this.testData.questions = questions;
        }
        this.$forceUpdate();
      }
    },
    testData: {
      deep: true,
      handler(v) {
        this.$emit("input", v);
      }
    },
    snackBarText() {
      this.showSnackBar = true;
    }
  },
  computed: {
    ...mapState("user", {
      userData: state => state,
      userClasses: state => state.classes
    }),
    BaseInfo() {
      return {
        name: {
          component: VTextField,
          label: "Название теста"
        },
        // groups: {
        //   component: VSelect,
        //   label: "Выберите класс",
        //   multiple: true,
        //   items: this.userClasses?.map(c => c.name) || []
        // },
        // type: {
        //   component: VSelect,
        //   label: "Вид тестирования",
        //   items: ["Традиционный", "Адаптиврованный"]
        // }
      };
    },
    questionsScheme() {
      return [];
    }
  },
  created() {},
  mounted() {},
  methods: {
    editQuestion(id) {
      this.editableQuestion = this.testData.questions.find(
        question => question.id === id
      );
      this.isBuildMode = true;
      this.snackBarText = "Вы успешно отредактировали вопрос!";
    },
    deleteQuestion(id) {
      if (this.editableQuestion?.id === id) {
        this.editableQuestion = {};
        this.isBuildMode = false;
      }
      const idx = this.testData.questions.findIndex(item => item.id === id);
      const newQuestionsArr = this.testData.questions
        .splice(idx, 1)
        .map((item, i) => ({ ...item, id: i + 1 }));
      this.questions = newQuestionsArr;
      this.$forceUpdate();
    },
    saveEditedQuestion(v) {
      const { id } = v;
      this.$set(this.testData.questions, id - 1, v);
      this.editableQuestion = null;
      this.isBuildMode = false;
    },
    createHandle(v) {
      const id = this.testData.questions.length + 1;
      this.testData.questions = [...this.testData.questions, { id, ...v }];
      this.snackBarText = "Вы успешно добавили вопрос!";
      this.isBuildMode = false;
    },
    changeFormHandler(obj) {
      const reducer = (acc, value) => {
        const fieldName = value[0];
        const fieldValue = value[1];

        return Object.assign(acc, { [fieldName]: fieldValue });
      };

      let formDataCopy = { ...this.BaseInfoData };
      let data = Object.entries(obj).reduce(reducer, {});

      let formData = Object.assign(formDataCopy, data);

      this.BaseInfoData = formData;
    },
    createQuestion() {
      if (this.editableQuestion) {
        this.editableQuestion = null;
        this.$forceUpdate();
      }
      this.isBuildMode = true;
    },
    cancelHandle() {
      this.editableQuestion = null;
      this.isBuildMode = false;
      this.$forceUpdate();
    }
  }
};
</script>
<style lang="scss">
.wrapper {
  width: 100%;
}
.builder-wrapper {
  width: 100%;
}
.card-tabs {
  width: 100%;
}
.v-card.green .v-tabs-bar {
  background: linear-gradient(60deg, #66bb6a, #43a047) !important;
}
</style>
